% Running this program will construct the histograms and call the WHAM
% algorithm.

close all
clear all
clc

load histdata.mat
load posdata.mat

for k = 1:length(T)
    T(k).minbin = min(T(k).hist(1).bins);
    T(k).maxbin = max(T(k).hist(1).bins);
    for j = 1:length(T(k).hist)
        if min(T(k).hist(j).bins)<T(k).minbin
            T(k).minbin = min(T(k).hist(j).bins);
        end
        if max(T(k).hist(j).bins)>T(k).maxbin
            T(k).maxbin = max(T(k).hist(j).bins);
        end
    end
end

for k = 1:length(T)
    T(k).bins = T(k).minbin:T(k).maxbin;
    T(k).counts = zeros(length(T(k).bins),1);
    for j = 1:length(T(k).hist)
        for l = 1:length(T(k).hist(j).data)
            for i = 1:length(T(k).bins)
                if T(k).bins(i)==T(k).hist(j).data(l,1)
                    T(k).counts(i)=T(k).counts(i)+T(k).hist(j).data(l,2);
                end
            end
        end
    end
   [T(k).maxcounts,T(k).maxbin] = max(T(k).counts);
    T(k).avgU = T(k).bins(T(k).maxbin)/200;
end


for i = 1:length(T)
U(i).bins = T(i).bins;
U(i).counts = T(i).counts;
end

clear i 

Uminbin = min(U(1).bins);
Umaxbin = max(U(1).bins);

for j = 2:length(U)
    if min(U(j).bins)<Uminbin
        Uminbin = min(U(j).bins);
    end
    if max(U(j).bins)>Umaxbin
        Umaxbin = max(U(j).bins);
    end
end

Ctot.bins = Uminbin:1:Umaxbin;
Ctot.counts = zeros(length(Ctot.bins),1);
for k = 1:length(Ctot.bins)
for i = 1:length(U)
    for j = 1:length(U(i).bins)
            if Ctot.bins(k) == U(i).bins(j)
                Ctot.counts(k) = Ctot.counts(k) + U(i).counts(j);
            end
        end
    end
end

Ctot.bins = Ctot.bins / 200;
n = sum(U(1).counts);
Atol = 10^-14;
maxIter = 10000;

[A,S,delta] = WHAM(Ctot,n,J, beta, Atol, maxIter);

clear i j k l 

save wham.mat A S delta T Ctot

% This part of the code builds the gr for 4 different temperatures.

g(1).hist = gr(coord65',5.848,200,1)';
g(1).Temperature = 0.65;
g(2).hist = gr(coord85',5.848,200,1)';
g(2).Temperature = 0.85;
g(3).hist = gr(coord105',5.848,200,1)';
g(3).Temperature = 1.05;
g(4).hist = gr(coord125',5.848,200,1)';
g(4).Temperature = 1.25;

save grs.mat g

clear coord65 coord85 coord105 coord125
